;
;       Mastermind      (MK14 Manual)
;
;       run from 0F1Ch
;
;       Term new game
;       Mem clear
;       Go process
;

#define DatPtr(x)       ((x)+1)         ; useful SC/MP macros
#define High(x)         ((x)/256)
#define Low(x)          ((x) & 255)

Disp    .equ    0D00h
Ram     .equ    0F00h
Crom    .equ    010Bh
Adr     .equ    011Bh
Dispa   .equ    015Ah

Dl      .equ    0
Dh      .equ    1
Adll    .equ    4
Adl     .equ    12
Adh     .equ    14
Ddta    .equ    15
Row     .equ    16
Next    .equ    17
Key     .equ    20

Digits  .equ    0F14h

        .org    0F1Ch

Start:  ldi     0
        st      DatPtr(Adl+Ram)
        st      DatPtr(Adh+Ram)
        xpal    2
        ldi     0Fh
        xpah    2
        ;
        ; choose random number
        ;
        ldi     High(Crom)
        xpah    3
        ldi     Low(Crom)
        xpal    3
NoKey:  ldi     4
        st      Row(2)
        ldi     High(Digits)
        xpah    1
        ldi     Low(Digits)
        xpal    1
        scl
Incr:   ld      4(1)
        dai     90h
        st      4(1)
        ani     0Fh
        xae
        ld      80h(3)
        st      @1(1)
        dld     Row(2)
        jnz     Incr

        ldi     High(Disp)
        xpah    1
        ldi     Low(Disp)
        xpal    1
        ld      3(1)
        xri     0FFh
        jz      NoKey
        ;
        ; enter your guess
        ;
Clear:  ldi     0FFh
        st      Ddta(2)
Blank:  ldi     0
        st      Dl(2)
        st      Dh(2)
Nchar:  ccl
        ldi     High(Dispa)
        xpah    3
        ldi     Low(Dispa)-1
        xpal    3
        xppc    3
        jmp     Comd
        lde
        adi     0F6h
        jp      Nchar
        ldi     Low(Adr)-1
        xpal    3
        xppc    3
        jmp     Blank
Comd:   xri     3
        jz      Start-0F00h-1(2)
        xri     5
        jnz     Clear
        ldi     Low(Crom)
        st      Dl(2)
        st      Dh(2)
Bulls:  ldi     0Fh
        xpah    1
        ldi     Low(Key)
        xpal    1
        ldi     80h
        xae
        ldi     4
        st      Next(2)
Bull2:  ld      Adll-Key(1)
        xor     @1(1)
        jnz     Nobul
        ild     Dh(2)
        ld      -1(1)
        ore
        st      -1(1)
        ld      Adll-Key-1(1)
        ore
        st      Adll-Key-1(1)
Nobul:  dld     Next(2)
        jnz     Bull2
Cows:   ldi     4
        st      Next(2)
Nerow:  ldi     4
        st      Row(2)
        ldi     0Fh
        xpah    3
        ldi     Low(Adll)+4
        xpal    3
        ld      @-1(1)
        jp      Try
Nocow:  dld     Next(2)
        jnz     Nerow
        jmp     Finito
Notry:  dld     Row(2)
        jz      Nocow
Try:    ld      (1)
        xor     @-1(3)
        jnz     Notry
        ild     Dl(2)
        ld      (3)
        ore
        st      (3)
        jmp     Nocow
Finito: ldi     4
        st      Next(2)
Unset:  ld      (1)
        ani     7Fh
        st      @1(1)
        dld     Next(2)
        jnz     Unset
        ldi     High(Crom)
        xpah    1
        ld      Dl(2)
        xpal    1
        ld      (1)
        st      Dl(2)
        ld      Dh(2)
        xpal    1
        ld      (1)
        st      Dh(2)
        ldi     0FFh
        st      Ddta(2)
        jmp     Nchar-0F00h-1(2)
        .end

